Deluge Bittorrent Szerver

Szerző: Ványi Albert |

A bejegyzésből megtudhatod, hogy hogyan telepítsd a Deluge bittorrent klienst, debian linux alapú szerverre forrásból. Az alaprendszerem Debian8 “Jessie”

 

Szerver és Webkliens telepítése

Első lépésben frissítsd a rendszereden lévő csomagokat:

sudo apt-get update && sudo apt-get upgrade

Telepítsük a program függőségeit:

sudo apt-get install python python-twisted python-twisted-web python-openssl python-simplejson python-setuptools intltool python-xdg python-chardet geoip-database python-libtorrent python-notify python-pygame python-glade2 librsvg2-common xdg-utils python-mako

Lépjünk be a /tmp könyvtárba, majd adjuk ki az alábbi utasításokat:

mkdir deluge
cd deluge/
wget http://download.deluge-torrent.org/source/deluge-1.3.11.tar.bz2
tar xvf deluge-1.3.11.tar.bz2
cd deluge-1.3.11/

Miután beléptünk a könyvtárba, adjuk ki a következő parancsokat:

python setup.py clean -a
python setup.py build
sudo python setup.py install
sudo python setup.py install_data

Miután elkészültünk, lépjünk vissza a könyvtárakból és töröljük azokat:

cd ../..
sudo rm -Rf deluge/

Hozzuk létre a deluge felhasználót a rendszeren:

sudo adduser --system --group --home /var/lib/deluge deluge

Majd addj hozzá tetszőleges felhasználót a deluge csoporthoz, az alábbi példa szerint:

sudo adduser pi deluge

Készítsük el a program futtatásához szükséges init scriptet:

sudo nano /etc/default/deluge-daemon

Másold be az alábbi tartalmat:

# Configuration for /etc/init.d/deluge-daemon
 
# The init.d script will only run if this variable non-empty.
DELUGED_USER="deluge"
 
# Should we run at startup?
RUN_AT_STARTUP="YES"

Mentsd el a tartalmat a Ctrl+O, Ctrl+X billentyű parancsokkal.

Készítsük el a /etc/init.d/deluge-daemon fájlt:

sudo nano /etc/init.d/deluge-daemon

Másold be az alábbi tartalmat:

#!/bin/sh
### BEGIN INIT INFO
# Provides:          deluge-daemon
# Required-Start:    $local_fs $remote_fs
# Required-Stop:     $local_fs $remote_fs
# Should-Start:      $network
# Should-Stop:       $network
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Daemonized version of deluge and webui.
# Description:       Starts the deluge daemon with the user specified in
#                    /etc/default/deluge-daemon.
### END INIT INFO
 
# Author: Adolfo R. Brandes 
 
PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DESC="Deluge Daemon"
NAME1="deluged"
NAME2="deluge"
DAEMON1=/usr/local/bin/deluged
DAEMON1_ARGS="-d"             # Consult `man deluged` for more options
DAEMON2=/usr/local/bin/deluge-web
DAEMON2_ARGS=""               # Consult `man deluge-web` for more options
PIDFILE1=/var/run/$NAME1.pid
PIDFILE2=/var/run/$NAME2.pid
UMASK=022                     # Change this to 0 if running deluged as its own user
PKGNAME=deluge-daemon
SCRIPTNAME=/etc/init.d/$PKGNAME
 
# Exit if the package is not installed
[ -x "$DAEMON1" -a -x "$DAEMON2" ] || exit 0
 
# Read configuration variable file if it is present
[ -r /etc/default/$PKGNAME ] && . /etc/default/$PKGNAME
 
# Load the VERBOSE setting and other rcS variables
[ -f /etc/default/rcS ] && . /etc/default/rcS
 
# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions
 
if [ -z "$RUN_AT_STARTUP" -o "$RUN_AT_STARTUP" != "YES" ]
then
   log_warning_msg "Not starting $PKGNAME, edit /etc/default/$PKGNAME to start it."
   exit 0
fi
 
if [ -z "$DELUGED_USER" ]
then
    log_warning_msg "Not starting $PKGNAME, DELUGED_USER not set in /etc/default/$PKGNAME."
    exit 0
fi
 
#
# Function that starts the daemon/service
#
do_start()
{
   # Return
   #   0 if daemon has been started
   #   1 if daemon was already running
   #   2 if daemon could not be started
   start-stop-daemon --start --background --quiet --pidfile $PIDFILE1 --exec $DAEMON1 \
      --chuid $DELUGED_USER --user $DELUGED_USER --umask $UMASK --test > /dev/null
   RETVAL1="$?"
   start-stop-daemon --start --background --quiet --pidfile $PIDFILE2 --exec $DAEMON2 \
      --chuid $DELUGED_USER --user $DELUGED_USER --umask $UMASK --test > /dev/null
   RETVAL2="$?"
   [ "$RETVAL1" = "0" -a "$RETVAL2" = "0" ] || return 1
 
   start-stop-daemon --start --background --quiet --pidfile $PIDFILE1 --make-pidfile --exec $DAEMON1 \
      --chuid $DELUGED_USER --user $DELUGED_USER --umask $UMASK -- $DAEMON1_ARGS
   RETVAL1="$?"
        sleep 2
   start-stop-daemon --start --background --quiet --pidfile $PIDFILE2 --make-pidfile --exec $DAEMON2 \
      --chuid $DELUGED_USER --user $DELUGED_USER --umask $UMASK -- $DAEMON2_ARGS
   RETVAL2="$?"
   [ "$RETVAL1" = "0" -a "$RETVAL2" = "0" ] || return 2
}
 
#
# Function that stops the daemon/service
#
do_stop()
{
   # Return
   #   0 if daemon has been stopped
   #   1 if daemon was already stopped
   #   2 if daemon could not be stopped
   #   other if a failure occurred
 
   start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --user $DELUGED_USER --pidfile $PIDFILE2
   RETVAL2="$?"
   start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --user $DELUGED_USER --pidfile $PIDFILE1
   RETVAL1="$?"
   [ "$RETVAL1" = "2" -o "$RETVAL2" = "2" ] && return 2
 
   rm -f $PIDFILE1 $PIDFILE2
 
   [ "$RETVAL1" = "0" -a "$RETVAL2" = "0" ] && return 0 || return 1
}
 
case "$1" in
  start)
   [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME1"
   do_start
   case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
   esac
   ;;
  stop)
   [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME1"
   do_stop
   case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
   esac
   ;;
  restart|force-reload)
   log_daemon_msg "Restarting $DESC" "$NAME1"
   do_stop
   case "$?" in
     0|1)
      do_start
      case "$?" in
         0) log_end_msg 0 ;;
         1) log_end_msg 1 ;; # Old process is still running
         *) log_end_msg 1 ;; # Failed to start
      esac
      ;;
     *)
        # Failed to stop
      log_end_msg 1
      ;;
   esac
   ;;
  *)
   echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
   exit 3
   ;;
esac
 
:

Mentsd el a tartalmat a Ctrl+O, Ctrl+X billentyű parancsokkal.

Tegyük futtathatóvá a root számára a scriptet, illetve állítsuk be, hogy a rendszerrel együtt induljon:

sudo chmod 755 /etc/init.d/deluge-daemon
sudo update-rc.d deluge-daemon defaults

Teszteljük le a munkánkat

Elindítás:

sudo /etc/init.d/deluge-daemon start

Megállítás:

sudo /etc/init.d/deluge-daemon stop

Újraindítás:

sudo /etc/init.d/deluge-daemon restart

Végül indítsuk újra a rendszert:

sudo reboot

Újraindítást követően, ha mindent jól csináltál, akkor a http://<servername>:8112/ linken el kell tudnod érni a deluge szerveredet.

Loggolás (Opcionális lehetősg)

Készítsük el a szükséges könyvtárakat

sudo mkdir -p /var/log/deluge/daemon
sudo mkdir /var/log/deluge/web
sudo chmod -R 755 /var/log/deluge
sudo chown -R deluge /var/log/deluge

Nyissuk meg a deluge-daemon scriptet

sudo nano /etc/init.d/deluge-daemon

Keressük meg az alábbi szekciót

DAEMON1=/usr/bin/deluged
DAEMON1_ARGS="-d"
DAEMON2=/usr/bin/deluge-web
DAEMON2_ARGS=""

Majd módosítsuk az alábbiak szerint

DAEMON1=/usr/local/bin/deluged
DAEMON1_ARGS="-d -L warning -l /var/log/deluge/daemon/warning.log"
DAEMON2=/usr/local/bin/deluge-web
DAEMON2_ARGS="-L warning -l /var/log/deluge/web/warning.log"

Mentsük el a változásokat, majd indítsuk újra a szolgáltatást

sudo /etc/init.d/deluge-daemon restart

Hozzuk létre az alábbi fájlt

sudo nano /etc/logrotate.d/deluge

Másuljuk be az alábbi tartalmat

/var/log/deluge/*/*.log {
    weekly
    missingok
    rotate 7
    compress
    notifempty
    copytruncate
    create 600
}

Mentsük a változást Ctrl+O, Ctrl+X billentyű parancsokkal.

Automatikus csatlakozás

Amennyiben azt szeretnénk, hogy a webes kliens automatikusan csatlakozzon indulásnál a daemon-hoz, hajtsuk végra a következő lépéseket. Először állítsuk le a daemon-t.

sudo /etc/init.d/deluge-daemon stop

Nyissuk meg a web.conf fájlt.

sudo nano /var/lib/deluge/.config/deluge/web.conf

Keressük meg az alábbi részt.

"default_daemon": "",

Módosítsuk az alábbiak szerint

"default_daemon": "127.0.0.1:58846",

Mentsük a változást Ctrl+O, Ctrl+X .

sudo /etc/init.d/deluge-daemon start

Távoli elérés

Amennyiben szeretnél távolról csatlakozni a daemon-hoz – asztali gépekhez készült grafikus klienssel -, akkor a következő lépéseket kell még megtenned. Indítsd el a webes klienset, és engedélyezd a távoli kapcsolódást.

  1. Kattints a felületen a beállításokra
  2. Keresd meg a kiszolgáló menüpontot
  3. Kattints a távoli kapcsolódás engedélyezésére

Állítsd be a felhasználónevet- és jelszót a konfigurációs állományban, valamint a megfelelő jogosultsági szintet. Bővebb információt erről ezen a linken találsz.

sudo chmod 770 /var/lib/deluge/.config/
sudo chmod 770 /var/lib/deluge/.config/deluge/
sudo chmod 660 /var/lib/deluge/.config/deluge/auth
echo username:password:10 >> /var/lib/deluge/.config/deluge/auth

Miután végeztél, indítsd újra a szolgáltatást

sudo /etc/init.d/deluge-daemon restart

A különböző operációs rendszerekhez készült deluge szoftvert ezen a linken éred el. Létezik mind Windows, mind Linux verziója is a programnak. Remélem hasznosnak találtad a leírást, azonban felhívnám a figyelmedet arra, hogy az egyes verziók telepítése között lehetnek különbségek, az esetleges ilyen jellegű hibákért nem vállalok felelősséget. A bejegyzéshez felhasznált forrást itt találod.